bibliotheque/urls.py
from django.contrib import admin
from  django.contrib.auth import views as auth_views
from django.urls import include, path

from . import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', views.index, name="index"),
    path('browse/', include('browse.urls')),
]

browse/urls.py
from django.urls import include, path
from django.contrib.auth import views as auth_views
from . import views

app_name = 'browse'
urlpatterns = [
    path('', views.index, name='index'),
    path('authors/', views.authors, name="authors"),
    path('authors/<int:author_id>/', views.author, name="author"),
    path('categories/', views.categories, name="categories"),
    path('categories/<int:category_id>/', views.category, name="category"),
    path('formats/', views.formats, name="formats"),
    path('formats/<int:format_id>/', views.format, name="format"),
    path('books/<int:book_id>/', views.book, name="book"),
    path('books/<int:book_id>/borrow/', views.borrow, name="borrow"),
    path('accounts/register/', views.register, name="register"),
    path('accounts/registered/', views.registered, name='registered'),
    path('accounts/login/', views.my_login, name='login'),
    path('accounts/logged/', views.logged, name='logged'),
    path('accounts/logout/', views.my_logout, name='logout'),
    path('accounts/profile/', views.profile, name='profile'),
    path('accounts/goback/<int:book_id>/', views.goback, name='goback'),
]

browse/models.py
from django.db import models
from django.contrib.auth.models import User

import random
import datetime

# Create your models here.


class Author(models.Model):
    author_id = models.AutoField(primary_key=True)
    name = models.CharField(blank=True, null=True, max_length=20)
    firstname = models.CharField(max_length=20)

    def __str__(self):
        if self.name:
            chaine = str(self.firstname) + " " + str(self.name)
            return chaine
        return self.firstname


class Category(models.Model):
    category_id = models.AutoField(primary_key=True)
    name = models.CharField(max_length=20)

    def __str__(self):
        return self.name


class Format(models.Model):
    format_id = models.AutoField(primary_key=True)
    name = models.CharField(max_length=10)

    def __str__(self):
        return self.name


class Language(models.Model):
    language_id = models.AutoField(primary_key=True)
    name = models.CharField(max_length=3)

    def __str__(self):
        return self.name


class Books(models.Model):
    book_id = models.AutoField(primary_key=True)
    title = models.CharField(max_length=200)
    is_borrowed = models.BooleanField(default=False)
    return_date = models.DateField(blank=True, null=True)
    ref = models.CharField(max_length=6, blank=True, null=True)
    image = models.CharField(blank=True, null=True, max_length=500)
    desc = models.TextField(max_length=10000, blank=True, null=True)
    author = models.ForeignKey(Author, on_delete=models.CASCADE)
    format = models.ForeignKey(Format, on_delete=models.CASCADE)
    language = models.ForeignKey(Language, on_delete=models.CASCADE)
    category = models.ForeignKey(Category, on_delete=models.CASCADE)
    borrowuser = models.ManyToManyField(User, blank=True, null=True)


    def create_ref(self):
        self.ref = self.title[0] + self.author.name[0] + str(random.randint(1000, 9999))

    def borrow(self):
        self.is_borrowed = True
        self.return_date = datetime.date.today() + datetime.timedelta(days=15)

    def get_back(self):
        self.is_borrowed = False
        self.return_date = None

    def __str__(self):
        return self.title


# class Drawer(models.Model):
#     drawer_id = models.AutoField(primary_key=True)
#     name = models.CharField(blank=True, null=True, max_length=20)
#     firstname = models.CharField(max_length=20)
#
#     def __str__(self):
#         if self.name:
#             chaine = self.firstname + " " + self.name
#             return chaine
#         return self.firstname
# class Comic(Books):
#     comic_id = models.AutoField(primary_key=True)
#     color = models.BooleanField()
#     drawer = models.ForeignKey(Drawer, on_delete=models.CASCADE)
#
#     def __str__(self):
#         return self.title
#
#
#
# class Users(models.Model):
#     login = models.CharField(max_length=22, blank=True, null=True)
#     name = models.CharField(max_length=20)
#     firstname = models.CharField(max_length=20)
#     password = models.CharField(max_length=20)
#     rank = models.IntegerField(default=1)
#     borrow = models.ManyToManyField(Books, blank=True, null=True)
#
#     def __str__(self):
#         return self.name[0].lower() + "." + self.firstname.lower()

browse/views.py
from django.shortcuts import render
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import get_object_or_404, render
from django.template import loader
from django.urls import reverse
from django.contrib.auth.models import User
from django.contrib.auth import authenticate, login, logout

from .models import *

# Create your views here.

def index(request):
    all_books = Books.objects.order_by('title')
    template = loader.get_template('browse/index.html')
    context = {'all_books':all_books}
    return HttpResponse(template.render(context,request))

def book(request, book_id):
    q = Books.objects.get(book_id=book_id)
    template = loader.get_template('browse/precise.html')
    context = {'book':q}
    return HttpResponse(template.render(context, request))


def authors(request):
    q = Author.objects.order_by('name')
    template = loader.get_template('browse/authors.html')
    context = {'all_authors': q}
    return HttpResponse(template.render(context, request))

def author(request, author_id):
    q = Books.objects.filter(author=author_id)
    template = loader.get_template('browse/author.html')
    context = {'books_by_author': q}
    return HttpResponse(template.render(context, request))

def categories(request):
    q = Category.objects.order_by('name')
    template = loader.get_template('browse/categories.html')
    context = {'all_categories': q}
    return HttpResponse(template.render(context, request))

def category(request, category_id):
    q = Books.objects.filter(category=category_id)
    template = loader.get_template('browse/category.html')
    context = {'books_by_category': q}
    return HttpResponse(template.render(context, request))

def formats(request):
    q = Format.objects.order_by('name')
    template = loader.get_template('browse/formats.html')
    context = {'all_formats': q}
    return HttpResponse(template.render(context, request))

def format(request, format_id):
    q = Books.objects.filter(format=format_id)
    template = loader.get_template('browse/format.html')
    context = {'books_by_format': q}
    return HttpResponse(template.render(context, request))

def borrow(request, book_id):
    book = get_object_or_404(Books, book_id=book_id)
    book.is_borrowed = True
    book.return_date = datetime.date.today() + datetime.timedelta(days=15)
    book.borrowuser.add(request.user)
    book.save()
    template = loader.get_template('browse/borrowed.html')
    context = {'book':book}
    return HttpResponse(template.render(context, request))

def register(request):
    return render(request, 'browse/register.html')

def registered(request):
    name = request.POST['user_name']
    firstname = request.POST['user_firstname']
    pwd = request.POST['user_pwd']
    email = request.POST['user_email']
    username = firstname[0].lower() + "." + name.lower()
    user = User.objects.create_user(username, email, pwd)
    user.last_name = name
    user.first_name = firstname
    user.save()
    template = loader.get_template('browse/registered.html')
    context = {'username': username, 'email': email, 'firstname': firstname}
    return HttpResponse(template.render(context, request))


def my_login(request):
    return render(request, 'browse/login.html')


def logged(request):
    username = request.POST['username']
    password = request.POST['password']
    user = authenticate(request, username=username, password=password)
    template = loader.get_template('browse/logged.html')
    invalid_template = loader.get_template('browse/error_log.html')
    context = {'user': user}
    if user is not None:
        login(request, user)
        return HttpResponse(template.render(context, request))
    else:
        return HttpResponse(invalid_template.render(context, request))

def my_logout(request):
    logout(request)
    return render(request, 'browse/logout.html')

def profile(request):
    borrows = Books.objects.filter(borrowuser=request.user)
    template = loader.get_template('browse/profile.html')
    context = {'borrows': borrows, 'qte': len(borrows)}
    return HttpResponse(template.render(context, request))


def goback(request, book_id):
    book = get_object_or_404(Books, book_id=book_id)
    book.is_borrowed = False
    book.return_date = None
    book.borrowuser.remove(request.user)
    book.save()
    return render(request, 'browse/goback.html')

browse/templates/browse/author.html
{% extends "browse/index.html" %}
{% block content %}
<div class="table-responsive">
    <table class="table table-striped table-sm">
        <thead>
        <td>REF</td>
        <td>Titre</td>
        <td>Auteur</td>
        <td>Catégorie</td>
        <td>Genre</td>
        <td>Langue</td>
        <td>Date de retour</td>
        <td>Emprunter</td>
        </thead>
        {% for book in books_by_author %}
        <tr>
            <td>{{book.ref}}</td>
            <td><a href="/browse/book/{{ book.book_id }}/">{{book.title}}</a></td>
                <td>{{book.author}}</td>
            <td>{{book.format}}</td>
            <td>{{book.category}}</td>
            <td>{{book.language}}</td>
            {% if book.is_borrowed == False %}
                <td>Disponible</td>
            {% else %}
                <td>{{ book.return_date }}</td>
            {% endif %}
            <td>
                {% if book.is_borrowed == False %}
                <form id="borrow" action="{% url 'browse:borrow' book.book_id %}">
                    <input type="submit" value="emprunter">
                </form>
                {% endif %}
            </td>
        </tr>
        {% endfor %}
    </table>
</div>
{% endblock %}

browse/templates/browse/authors.html
{% extends "browse/index.html" %}
{% block content %}
<div class="table-responsive">
    <table class="table table-striped table-sm">
        <thead>
            <td>Auteurs</td>
        </thead>
        {% for author in all_authors %}
        <tr>
            <td><a href="/browse/authors/{{ author.author_id }}">{{author}}</a></td>
        </tr>
        {% endfor %}
    </table>
</div>
{% endblock %}

browse/templates/browse/base.html
<!DOCTYPE html>
<html lang="fr">
    {% load static %}
    <head>
        <title>{% block title %}Bibliotheque de poudlard{% endblock %}</title>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <link rel="canonical" href="https://getbootstrap.com/docs/5.0/examples/dashboard/">
        <!-- Bootstrap core CSS -->
        <link href="{% static 'browse/assets/dist/css/bootstrap.min.css' %}" rel="stylesheet">
        <style>
                  .bd-placeholder-img {
                  font-size: 1.125rem;
                  text-anchor: middle;
                  -webkit-user-select: none;
                  -moz-user-select: none;
                  user-select: none;
                  }

                  @media (min-width: 768px) {
                  .bd-placeholder-img-lg {
                  font-size: 3.5rem;
                  }
                  }
                  </style>
        <!-- Custom styles for this template -->
        <script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>
    </head>

    <body>
        <header class="navbar navbar-dark sticky-top bg-dark flex-md-nowrap p-0 shadow">
            {% block topbar %}
            <a class="navbar-brand col-md-3 col-lg-2 me-0 px-3" href="{% url 'browse:index' %}">Poudlard</a>
            {% if request.user.is_authenticated %}
            <a class="navbar-brand col-md-3 col-lg-2 me-0 px-3" href="{% url 'browse:index' %}">Profile</a>
            <a class="navbar-brand col-md-3 col-lg-2 me-0 px-3" href="{% url 'browse:logout' %}">Déconnexion</a>
            {% else %}
            <a class="navbar-brand col-md-3 col-lg-2 me-0 px-3" href="{% url 'browse:login' %}">Connexion</a>
            <a class="navbar-brand col-md-3 col-lg-2 me-0 px-3" href="{% url 'browse:register' %}">Inscription</a>
            {% endif %}
            {% endblock %}
        </header>
        <div class="row">
            <nav id="sidebarMenu" class="col-md-3 col-lg-2 d-md-block bg-light sidebar collapse">
            {% block sidebar %}
                <ul class="nav flex-column mb-2">
                <li class="nav-item"><a class="nav-link" href="{% url 'browse:index' %}"><span data-feather="file-text"></span>Afficher tous les livres</a></li>
                <li class="nav-item"><a class="nav-link" href="{% url 'browse:authors' %}"><span data-feather="file-text"></span>Afficher tous les auteurs</a></li>
                <li class="nav-item"><a class="nav-link" href="{% url 'browse:categories' %}"><span data-feather="file-text"></span>Afficher toutes les catégories</a></li>
                <li class="nav-item"><a class="nav-link" href="{% url 'browse:formats' %}"><span data-feather="file-text"></span>Afficher tous les formats</a></li>
                </ul>
            {% endblock %}
            </nav>
            <main class="col-md-9 ms-sm-auto col-lg-10 px-md-4" id="centre">
                {% block content %} {% endblock %}
            </main>
        </div>
    </body>
</html>

browse/templates/browse/error_log.html
{% extends "browse/index.html" %}
{% block content %}
{% load static %}
{% load i18n %}
<p>Erreur, utilisateur inconnu</p>
{% endblock %}

browse/templates/browse/format.html
{% extends "browse/index.html" %}
{% block content %}
{% load static %}
{% load i18n %}
<div class="table-responsive">
    <table class="table table-striped table-sm">
        <thead>
        <td>REF</td>
        <td>Titre</td>
        <td>Auteur</td>
        <td>Catégorie</td>
        <td>Genre</td>
        <td>Langue</td>
        <td>Date de retour</td>
        <td>Emprunter</td>
        </thead>
        {% for book in books_by_format %}
        <tr>
            <td>{{book.ref}}</td>
            <td><a href="/browse/books/{{ book.book_id }}/">{{book.title}}</a></td>
            <td>{{book.author}}</td>
            <td>{{book.format}}</td>
            <td>{{book.category}}</td>
            <td>{{book.language}}</td>
            {% if book.is_borrowed == False %}
            <td>Disponible</td>
            {% else %}
            <td>{{ book.return_date }}</td>
            {% endif %}
            <td>
                {% if book.is_borrowed == False %}
                <form id="borrow" action="{% url 'browse:borrow' book.book_id %}">
                    <input type="submit" value="emprunter">
                </form>
                {% endif %}
            </td>
        </tr>
        {% endfor %}
    </table>
</div>
{% endblock %}

browse/templates/browse/goback.html
{% extends "browse/index.html" %}
{% load static %}
{% load i18n %}
{% block content %}
<p>Le livre a été rendu !</p>
{% endblock %}

browse/templates/browse/index.html
<!DOCTYPE html>
<html lang="fr">
{% load static %}
{% load i18n %}
<head>
    <title>{% block title %}Bibliotheque de poudlard{% endblock %}</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="canonical" href="https://getbootstrap.com/docs/5.0/examples/dashboard/">
    <!-- Bootstrap core CSS -->
    <link href="{% static 'browse/assets/dist/css/bootstrap.min.css' %}" rel="stylesheet">
    <style>
                  .bd-placeholder-img {
                  font-size: 1.125rem;
                  text-anchor: middle;
                  -webkit-user-select: none;
                  -moz-user-select: none;
                  user-select: none;
                  }

                  @media (min-width: 768px) {
                  .bd-placeholder-img-lg {
                  font-size: 3.5rem;
                  }
                  }
                  </style>
    <!-- Custom styles for this template -->
    <script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>
</head>

<body>
<header class="navbar navbar-dark sticky-top bg-dark flex-md-nowrap p-0 shadow">
    {% block topbar %}
    <a class="navbar-brand col-md-3 col-lg-2 me-0 px-3" href="{% url 'browse:index' %}">Poudlard</a>
    {% if request.user.is_authenticated %}
    <a class="navbar-brand col-md-3 col-lg-2 me-0 px-3" href="{% url 'browse:profile' %}">Profile</a>
    <a class="navbar-brand col-md-3 col-lg-2 me-0 px-3" href="{% url 'browse:logout' %}">Déconnexion</a>
    {% else %}
    <a class="navbar-brand col-md-3 col-lg-2 me-0 px-3" href="{% url 'browse:login' %}">Connexion</a>
    <a class="navbar-brand col-md-3 col-lg-2 me-0 px-3" href="{% url 'browse:register' %}">Inscription</a>
    {% endif %}
    {% endblock %}
</header>
<div class="row">
    <nav id="sidebarMenu" class="col-md-3 col-lg-2 d-md-block bg-light sidebar collapse">
        {% block sidebar %}
        <ul class="nav flex-column mb-2">
            <li class="nav-item"><a class="nav-link" href="{% url 'browse:index' %}"><span data-feather="file-text"></span>Afficher tous les livres</a></li>
            <li class="nav-item"><a class="nav-link" href="{% url 'browse:authors' %}"><span data-feather="file-text"></span>Afficher tous les auteurs</a></li>
            <li class="nav-item"><a class="nav-link" href="{% url 'browse:categories' %}"><span data-feather="file-text"></span>Afficher toutes les catégories</a></li>
            <li class="nav-item"><a class="nav-link" href="{% url 'browse:formats' %}"><span data-feather="file-text"></span>Afficher tous les formats</a></li>
        </ul>
        {% endblock %}
    </nav>
    <main class="col-md-9 ms-sm-auto col-lg-10 px-md-4" id="centre">
        {% block content %}
            <div class="table-responsive">
                <table class="table table-striped table-sm">
                    <thead>
                        <td>REF</td>
                        <td>Titre</td>
                        <td>Auteur</td>
                        <td>Catégorie</td>
                        <td>Genre</td>
                        <td>Langue</td>
                        <td>Date de retour</td>
                        <td>Emprunter</td>
                    </thead>
                    {% for book in all_books %}
                    <tr>
                        <td>{{book.ref}}</td>
                        <td><a href="/browse/books/{{ book.book_id }}/">{{book.title}}</a></td>
                        <td>{{book.author}}</td>
                        <td>{{book.format}}</td>
                        <td>{{book.category}}</td>
                        <td>{{book.language}}</td>
                        {% if book.is_borrowed == False %}
                            <td>Disponible</td>
                        {% else %}
                            {% language 'fr' %}
                            <td>{{ book.return_date |date:'d F Y'}}</td>
                            {% endlanguage %}
                        {% endif %}
                        <td>
                            {% if book.is_borrowed == False %}
                                <form id="borrow" action="{% url 'browse:borrow' book.book_id %}">
                                    <input type="submit" value="emprunter">
                                </form>
                            {% endif %}
                        </td>
                    </tr>
                    {% endfor %}
                </table>
            </div>
        {% endblock %}
        </main>

    </div>
</body>

browse/templates/browse/logged.html
{% extends "browse/index.html" %}
{% block content %}
{% load static %}
{% load i18n %}
<p>Bienvenue {{user.first_name}}</p>
{% endblock %}

browse/templates/browse/login.html
{% extends "browse/index.html" %}
{% block content %}
{% load static %}
{% load i18n %}
<form id ="login" method="post" action="{% url 'browse:logged' %}">
    {% csrf_token %}
    <table class='table table-striped table-sm'>
        <tr>
            <td>
                <label for="username">Login</label>
                <input id="username" name="username">
            </td>
            <td>
                <label for="password">Mot de passe</label>
                <input id="password" name="password">
            </td>
        </tr>
        <tr>
            <td>
                <input type="submit" value="Connexion">
                <input type="hidden" name="next" value="{{next}}">
            </td>
        </tr>
    </table>
</form>
{% endblock %}

browse/templates/browse/logout.html
{% extends "browse/index.html" %}
{% block content %}
{% load static %}
{% load i18n %}
<p>Méfaits accomplis</p>
{% endblock %}

browse/templates/browse/precise.html
{% extends "browse/index.html" %}
{% block content %}
{% load static %}
{% load i18n %}
<div id="entete">
    <div id="texte">
        <h1>{{book.title}}</h1>
        <div id="content">
            <div id="desc">
                <p>{{book.desc}}</p>
            </div>
            <div id="infos">
                <p>Auteur : {{book.author}}</p>
                <p>Format : {{book.format}}</p>
                <p>Catégorie : {{book.category}}</p>
                {% if book.is_borrowed == False %}
                    <p>Disponible à l'emprunt</p>
                {% else %}
                    {% language 'fr' %}
                    <p>Non disponible, de retour le {{book.return_date|date:'d F Y'}}</p>
                    {% endlanguage %}
                {% endif %}
            </div>
        </div>
    </div>
    <img src="{% static 'browse/images/' %}{{book.image}}">
</div>
<form id="borrow" action="{% url 'browse:borrow' book.book_id %}">
    <input type="submit" value="emprunter">
</form>
{% endblock %}

browse/templates/browse/profile.html
{% extends "browse/index.html" %}
{% load static %}
{% load i18n %}
{% block content %}
<h1>{{user.firstname}} {{user.name}}</h1>
<p>Tu as actuellement {{qte}} livre(s) en ta possession</p>
{% if  qte != 0 %}
    <ul>
    {% for book in borrows %}
        {% language 'fr' %}
        <li>
            <a href="/browse/books/{{ book.book_id }}/">{{book.title}}</a> de {{book.author}} à rendre avant le {{book.return_date|date:'d F Y'}}
            <form id="borrow" action="{% url 'browse:goback' book.book_id %}">
                <input type="submit" value="rendre">
            </form>
        </li>
        {% endlanguage %}
    {% endfor %}
    </ul>
{% endif %}
{% endblock %}

browse/templates/browse/register.html
{% extends "browse/index.html" %}
{% block content %}
{% load static %}
{% load i18n %}
<form id="register" action="{% url 'browse:registered' %}" method="post">
    {% csrf_token %}
    <table class='table table-striped table-sm'>
        <tr>
            <td><label for="user_name">Nom</label>
            <input id="user_name" name="user_name"></td>
        </tr>
        <tr><td>
            <label for="user_firstname">Prénom</label>
            <input id="user_firstname" name="user_firstname">
        </td></tr>
        <tr><td>
            <label for="user_email">Email</label>
            <input id="user_email" name="user_email">
        </td></tr>
        <tr><td>
            <label for="user_pwd">Mot de passe</label>
            <input id="user_pwd" name="user_pwd">
        </td></tr>
        <tr><td>
        <input type="submit" value="Enregistrer">
        </td></tr>
    </table>
</form>
{% endblock %}

browse/templates/browse/registered.html
{% extends "browse/index.html" %}
{% block content %}
{% load static %}
{% load i18n %}
<p>Bienvenue {{firstname}}, pour vous connecter veuillez utiliser le login suivant :</p>
<p><strong>{{username}}</strong></p>
<p>Dans le cas ou vous oublieriez votre mot de passe votre adresse email <strong>{{email}}</strong> vous sera demandé pour le réinitialiser</p>
{% endblock %}